/*
 * meteo.c
 *
 * Copyright (c) 2001- Kenta Cho. All rights reserved.
 */
#include "galib.h"
#include "mprm_C_usr.h"

/**
 * METEORITE main source.
 *
 * @author cs8k-cyu@asahi-net.or.jp
 * @version 0.1
 */

MESSAGE* _GlobalMessage;

ULONG lastCnt;
#define INTERVAL 3

void AppInit() {
  GaVect light;
  setWindowHandle(GaGetScreenWp());
  clearScreen();
  light.x = DV(0); light.y = DV(0); light.z = DV(1);
  GaVectNormalize(&light);
  GaSetLightDirection(light.x, light.y, light.z);
  GaSetScreenPosition(40, 80);
  srand(GetSystemTickCount());
  init();
  lastCnt = GetFastTickCount();
}

void AppQuit() {
}

void AppMove() {
  int moveCnt;
  ULONG thisCnt, delay;
  int i;

  switch( _GlobalMessage->CommonMsg.MessageID ) {
  case OnBreakID:
    //_GlobalMessage->CommonMsg.MessageID= NullMessageID;
    break;
  case AppliOutID:
    break;
  case KeyDownID:
    switch( _GlobalMessage->KeyDown.KeyCode ){
    case KC_BACK:
      _GlobalMessage->CommonMsg.MessageID= OnBreakID;
      break;
    }
    break;
  }
  thisCnt = GetFastTickCount();
  delay = thisCnt-lastCnt;
  if ( delay >= INTERVAL ) {
    moveCnt = delay/INTERVAL;
    if ( moveCnt < 1 ) {
      moveCnt = 1;
    } else if ( moveCnt > 4 ) {
      moveCnt = 4;
    }
    for ( i=0 ; i<moveCnt ; i++ ) {
      move();
    }
    lastCnt = thisCnt;
  }
}

void AppDraw() {
  GaClear(RGBS_MAKE(0,0,0,0));
  draw();
  GaDraw();
}

void redisp() {
  redispScreen();
}
