/*
 * meteo.h
 *
 * Copyright (c) 2001- Kenta Cho. All rights reserved.
 */

/**
 * Meteorite header file.
 *
 * @author cs8k-cyu@asahi-net.or.jp
 * @version 0.2
 */

#define randN(N) ((int)((rand()&0x7fff)*(N))>>15)

#define METEO_MODEL_NUM 4
#define FRAG_MODEL_NUM 4

#define TAIL_NUM 4

// game manager
#define TITLE 0
#define GAME_IN_PROGRESS 1
#define HIT 2
#define GAME_OVER 3

typedef struct {
  int status;
  int cnt;
} GameStatus;

typedef struct {
  DVAL x, y, z;
  int d1, d2;
  DVAL mx, my, mz;
  int md1, md2;
  int sx, sy;
  int prvLockedKey;
  int speed, cnt, type;
  DVAL ax, ay, az;
  GaModel *model;
  int tailDeg[TAIL_NUM];
  int tailDegMv[TAIL_NUM];
} Meteo;

#define LASER_LENGTH 4

typedef struct {
  DVAL x[LASER_LENGTH], y[LASER_LENGTH], z[LASER_LENGTH];
  int idx;
  BOOLEAN showAll;
  DVAL mx, my, mz;
  Meteo *aim;
  int lockCnt;
} Laser;

typedef struct {
  int x, y;
} LaserSight;

typedef struct {
  DVAL x, y, z;
  int d1, d2;
  DVAL mx, my, mz;
  int md1, md2;
  int cnt;
  int type;
} Frag;

extern void init();
extern void move();
extern void draw();
extern void drawLeft();
extern void drawScore();

// model maker
extern void makeModel(GaModel*, float[], int[], int, int);
extern void makeModels();

// screen manager
extern void setWindowHandle(WINDOWHD);
extern void clearScreen();
extern void drawView();
extern void drawNum(int, int);
extern void drawTitleFirst();
extern void drawTitle(int);
extern void drawGameover();
extern void redispScreen();

// sound manager
extern void initSound();
extern void playSe(int);
