/*
 * screenmanager.c
 *
 * Copyright (c) 2001- Kenta Cho. All rights reserved.
 */
#include "galib.h"
#include "bslib.h"
#include "meteo.h"
#include "mprm_res.h"

/**
 * Draw bitmap images.
 *
 * @author cs8k-cyu@asahi-net.or.jp
 * @version 0.2
 */
static WINDOWHD wh;
static RESOURCE imgRes;

void setWindowHandle(WINDOWHD h) {
  wh = h;
  memcpy(imgRes.ResFile, "MPRMIM00", 9);
}

void clearRect(int x1, int y1, int x2, int y2) {
  POINT Start, End;
  COLOR Fg;
  WINDOWHD wh = GaGetScreenWp();
  Start.x = x1<<2;
  Start.y = y1<<2;
  End.x = x2<<2;
  End.y = y2<<2;
  SetColorV(&Fg, BLACK);
  AreaClear(wh, &Start, &End, &Fg, FSET, NULL);
}

void clearScreen() {
  clearRect(0, 0, 240, 320);
}

void drawView() {
  RECTANGLE rct;
  clearRect(0, 0, 240, 80);
  clearRect(0, 240, 240, 320);
  rct.left = 0; rct.top = 240<<2; 
  imgRes.ResID = LeftImgID;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
  rct.left = 0; rct.top = 60<<2; 
  imgRes.ResID = ScoreImgID;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
  rct.left = 32<<2; rct.top = 80<<2; 
  imgRes.ResID = Frame1ImgID;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
  rct.left = 200<<2; rct.top = 80<<2; 
  imgRes.ResID = Frame2ImgID;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
  rct.left = 32<<2; rct.top = 232<<2; 
  imgRes.ResID = Frame3ImgID;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
  rct.left = 200<<2; rct.top = 232<<2; 
  imgRes.ResID = Frame4ImgID;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
}

static USHORT numId[] = {
  ZeroImgID, OneImgID, TwoImgID, ThreeImgID, FourImgID,
  FiveImgID, SixImgID, SevenImgID, EightImgID, NineImgID
};

void drawNum(int y, int n) {
  RECTANGLE rct;
  rct.left = 190<<2; rct.top = y<<2;
  do {
    imgRes.ResID = numId[(n%10)];
    DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
    n /= 10;
    rct.left -= 50<<2;
  } while ( n > 0 );
}

void drawTitleFirst() {
  RECTANGLE rct;
  clearRect(0, 240, 240, 320);
  imgRes.ResID = TitleImgID;
  rct.left = 0; rct.top = 240<<2;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
}

void drawTitle(int cnt) {
  RECTANGLE rct;
  switch ( cnt&31 ) {
  case 0:
    clearRect(0, 300, 240, 320);
    break;
  case 16:
    imgRes.ResID = PushImgID;
    rct.left = 0; rct.top = 300<<2;
    DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
    break;
  }
}

void drawGameover() {
  RECTANGLE rct;
  clearRect(0, 240, 240, 320);
  imgRes.ResID = GameoverImgID;
  rct.left = 0; rct.top = 240<<2;
  DrawImageRes(wh, &rct, 0, &imgRes, NORM_SCALE, NULL);
}

extern GameStatus gameStatus;

void redispScreen() {
  clearScreen();
  switch ( gameStatus.status ) {
  case TITLE:
    drawTitleFirst();
    break;
  case GAME_IN_PROGRESS:
  case HIT:
    drawView();
    drawScore();
    drawLeft();
    break;
  case GAME_OVER:
    drawGameover();
    break;
  }
}
